package memento;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author thsc
 */
public class FileWishlistMemento extends WishlistStringMemento 
        implements WishlistMemento {
    
    private final File mementoFile;
    
    FileWishlistMemento(File file) {
        this.mementoFile = file;
    }
    
    @Override
    public ArrayList<String> getWishlist() throws Exception {
        FileInputStream fis = new FileInputStream(this.mementoFile);
        DataInputStream dis = new DataInputStream(fis);
        
        String serializedWishes = dis.readUTF();
        dis.close();
        
        return this.getStringList(serializedWishes);
        
    }

    @Override
    public void saveWishlist(List<String> wishes) throws Exception {
        String serializedWishes = this.list2String(wishes);
        if(serializedWishes.length() == 0) return; 
        
        FileOutputStream fos = new FileOutputStream(this.mementoFile);
        DataOutputStream dos = new DataOutputStream(fos);
        
        dos.writeUTF(serializedWishes);
        dos.close();
    }
}
