package memento;

import java.io.PrintStream;
import java.util.Iterator;

/**
 *
 * @author thsc
 */
public interface Wishlist {
    /**
     * get iterator of wishes
     * @return iterator - can be emptys but never null
     */
    Iterator<String> getWishes();
    
    /**
     * Add wish. Wishes can be inserted more than once.
     * It's up to application to keep track of actual number
     * of identical wishes.
     * @param wish wish to add
     */
    void addWish(String wish);
    
    /**
     * Remove a wish. Nothing happens if this wish does
     * not exist. Only one wish is removed. Only one wish
     * is removed if two identical wishes are on the list
     * @param wish wish to be removed
     */
    void removeWish(String wish);
    
    /**
     * @return length of wish list
     */
    int size();
    
    void print(PrintStream os);
    
    /**
     * Save status with memento
     * @param memento 
     */
    void saveToMemento(WishlistMemento memento);
    
    /**
     * Restore status with memento
     * @param memento 
     */
    void restoreFromMemento(WishlistMemento memento);
}
