package memento;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author thsc
 */
public class WishlistImpl implements Wishlist {
    List<String> wishes = new ArrayList<>();

    @Override
    public Iterator<String> getWishes() {
        return this.wishes.iterator();
    }

    @Override
    public void addWish(String wish) {
        this.wishes.add(wish);
    }

    @Override
    public void removeWish(String wish) {
        this.wishes.remove(wish);
    }

    @Override
    public int size() {
        return this.wishes.size();
    }

    @Override
    public void print(PrintStream os) {
        os.println("List with " + this.size() + " wishes:");
        os.println("=======================");
        for(String wish : this.wishes) {
            os.println(wish);
        }
    }

    @Override
    public void saveToMemento(WishlistMemento memento) {
        try {
            memento.saveWishlist(this.wishes);
        } catch (Exception ex) {
            // do something about it
        }
    }

    @Override
    public void restoreFromMemento(WishlistMemento memento) {
        try {
            ArrayList<String> wishlist = memento.getWishlist();
            this.wishes = wishlist;
        } catch (Exception ex) {
            // failed - do something
        }
    }
}
