package memento;

import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

/**
 *
 * @author thsc
 */
abstract class WishlistStringMemento implements WishlistMemento {
    public final static String DELIMITER = "|||";
    
    protected String list2String(List<String> stringList) {
        StringBuilder builder = new StringBuilder();
        if(stringList != null && stringList.size() > 0) {
            for(String s : stringList) {
                builder.append(s);
                builder.append(DELIMITER);
            }
        }
        return builder.toString();
    }
    
    protected ArrayList<String> getStringList(String serializedString) {
        ArrayList<String> list = new ArrayList<>();
        StringTokenizer st = new StringTokenizer(serializedString, DELIMITER);
        while(st.hasMoreTokens()) {
            list.add(st.nextToken());
        }

        return list;
    }
}
